//+------------------------------------------------------------------+
//|                               Forex Generator version 4.4        |
//|                                 Copyright (C) 2011, Etasoft Inc. |
//|                                    http://www.forexgenerator.com |
//+------------------------------------------------------------------+
// Keywords: indicator developer, Forex indicator builder, create forex indicator, MT4


#property copyright "Your copyright"
#property link "Link to your website"
#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Blue
#property indicator_width2 2
#property indicator_color3 Green
#property indicator_width3 2

extern int  avgPeriod = 30;
extern bool showTotal = true;
extern bool showSmall = true;
extern bool showLarge = true;

double Buffer1[];
double Buffer2[];
double Buffer3[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
    SetIndexBuffer(0, Buffer1); if (showTotal) SetIndexStyle(0,DRAW_LINE); else SetIndexStyle(0,DRAW_NONE);
    SetIndexBuffer(1, Buffer2); if (showSmall) SetIndexStyle(1,DRAW_LINE); else SetIndexStyle(1,DRAW_NONE);
    SetIndexBuffer(2, Buffer3); if (showLarge) SetIndexStyle(2,DRAW_LINE); else SetIndexStyle(2,DRAW_NONE);
    IndicatorShortName("EVIndicator2011v6Noam");
    return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars -counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
    
   for(int i = limit; i >= 0; i--)
   {
      double totalVol = 0;
      for (int j = 0; j < avgPeriod; j++)
      {
         double tmp  = 0;
         double tmp2 = ((MathMax(High[i+j], Close[i+j+1]))-(MathMin(Low[i+j], Close[i+j+1])))+Point;
      	  if ( tmp2 > 0.00001 || tmp2 < -0.00001)  // filter out extremes
                tmp = (((Close[i+j]-Close[i+j+1])+Point)/tmp2)*Volume[i+j];
      	totalVol += MathAbs(tmp);
      }
      double avgVol = totalVol/avgPeriod; ChartLine3(i,avgVol);
    }
    return(0);
}

//
//
//
//
//

void ChartLine3(int i, double avgVol)
{
   double tmp4 = 0;
   double tmp3 = ((MathMax(High[i], Close[i+1]))-(MathMin(Low[i], Close[i+1])))+Point;
      if (tmp3 > 0.00001 || tmp3 < -0.00001)
           tmp4 = (((Close[i]-Close[i+1])+Point)/tmp3)*Volume[i];

      //
      //
      //
      //
      //
      
      if (i>=Bars-avgPeriod)
      {
         Buffer1[i] = 0;
         Buffer2[i] = 0;
         Buffer3[i] = 0;
         return;
      }
      else
      {
         Buffer1[i] = Buffer1[i+1];
         Buffer2[i] = Buffer2[i+1];
         Buffer3[i] = Buffer3[i+1];
      }         
      Buffer1[i] += tmp4;
      if (MathAbs(tmp4) < avgVol)
           Buffer2[i] += tmp4;
      else Buffer3[i] += tmp4;
      return;
}